<?
	// Timeout for opening socket
	$timeout = 30;

	// Timeout for reading from socket
	$read_timeout = 15;  // Seconds
	
	if (isset($_GET['url']))
	{					
		$parsed_url = parse_url($_GET['url']);
		
		$host = $parsed_url["host"];
		$port = $parsed_url["port"];
		$path = $parsed_url["path"];
		$query = $parsed_url["query"];  // This only returns what is after the ?, the others come in as key=values
		
		if ($port == 0 || $port == "")
		{
			$port = 80;
		} 
		
		if ($path == "")
		{
			$path = "/";
		}
		
		if ($query != "")
		{
			$equal_position = strrpos($query, "=");
			if (is_bool($equal_position) && !$equal_position)
			{
				// Not found, do nothing
			}
			else 
			{
				$query = substr($query,0,$equal_position+1) . urlencode(substr($query,$equal_position+1));
			}
			$path .= "?" . $query;			
		}

        	foreach ($_GET as $key => $value)
        	{
				if ($key != 'url')
				{
					$path .= '&' . $key . '=' . urlencode($value);
        		}
        	}
		
		$referer = "http://" . $host;
		
		$request = "GET " . $path . " HTTP/1.0\r\n" . "Host: " . $host . "\r\n";
		$request = $request . "Connection: Close\r\n";
		$request = $request . "\r\n";
		
		$fp = fsockopen($host, $port, $errno, $errstr, $timeout);
		
		if ($fp != false)
		{
			fwrite($fp, $request);	
			socket_set_timeout($fp,$read_timeout);			
			$isBody = false;
			$headers = "";
			while (!feof($fp))
			{
				$content = fgets($fp, 1024);
				if ($isBody)
				{
					echo $content;
				}
				else
				{
					$headers .= $content;
					if ($content == "\r\n")
					{
						$isBody = true;
						header($headers);
					}
				}	
			}
			fclose($fp);
		}
		else 
		{
			echo "Error Number: " . $errno . "<br>Error String: " . $errstr;
		}
	}
	else 
	{
		echo "Please specify a URL to load";
	}
?>